﻿using Syncfusion.UI.Xaml.Grid.Converter;
using Syncfusion.XlsIO;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.ApplicationModel.Activation;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace App1
{
    public sealed partial class MyUserControl1 : UserControl, IDisposable, IFileSavePickerContinuable
    {
        public static MyUserControl1 Current;
        public MyUserControl1()
        {
            this.InitializeComponent();
            Current = this;
        }
        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            var excelEngine = this.sfGrid.ExportCollectionToExcel(this.sfGrid.View, ExcelVersion.Excel2007,
                                                                  exportingHandler, CellExportingHandler, false);

            var workBook = excelEngine.Excel.Workbooks[0];
            var savePicker = new FileSavePicker
            {
                SuggestedStartLocation = PickerLocationId.Desktop,
                SuggestedFileName = "Sample1"
            };


            if (workBook.Version == ExcelVersion.Excel97to2003)
            {
                savePicker.FileTypeChoices.Add("Excel File (.xls)", new List<string>() { ".xls" });
            }
            else
            {
                savePicker.FileTypeChoices.Add("Excel File (.xlsx)", new List<string>() { ".xlsx" });
            }

            savePicker.PickSaveFileAndContinue();

            excelEngine.Dispose();

        }
        public async void ContinueFileSavePicker(FileSavePickerContinuationEventArgs args)
        {
            var excelEngine = this.sfGrid.ExportCollectionToExcel(this.sfGrid.View, ExcelVersion.Excel2007,
                                                                   exportingHandler, CellExportingHandler, false);

            var workBook = excelEngine.Excel.Workbooks[0];
            StorageFile storageFile = args.File;
            await workBook.SaveAsAsync(storageFile);

            var msgDialog = new MessageDialog("Do you want to view the Document?", "File has been created successfully.");

            var yesCmd = new UICommand("Yes");
            var noCmd = new UICommand("No");
            msgDialog.Commands.Add(yesCmd);
            msgDialog.Commands.Add(noCmd);
            var cmd = await msgDialog.ShowAsync();
            if (cmd == yesCmd)
            {
                // Launch the saved file
                bool success = await Windows.System.Launcher.LaunchFileAsync(storageFile);
            }

        }

        public void CellExportingHandler(object sender, GridCellExcelExportingEventArgs args)
        {
            args.Range.CellStyle.Font.FontName = "Segoe UI";
        }

        public void exportingHandler(object sender, GridExcelExportingEventArgs e)
        {
            if (e.CellType == ExportCellType.HeaderCell)
            {
                e.CellStyle.BackGroundBrush = new SolidColorBrush(Colors.LightSteelBlue);
                e.CellStyle.ForeGroundBrush = new SolidColorBrush(Colors.DarkRed);
                e.CellStyle.FontInfo.Bold = true;
            }
            else if (e.CellType == ExportCellType.GroupCaptionCell)
            {
                e.CellStyle.BackGroundBrush = new SolidColorBrush(Colors.LightSlateGray);
                e.CellStyle.ForeGroundBrush = new SolidColorBrush(Colors.LightYellow);
            }
            else if (e.CellType == ExportCellType.GroupSummaryCell)
            {
                e.CellStyle.BackGroundBrush = new SolidColorBrush(Colors.LightGray);
            }
            e.CellStyle.FontInfo.FontName = "Segoe UI";
        }

        public void Dispose()
        {
            sfGrid.ItemsSource = null;
            sfGrid.Dispose();
            (this.DataContext as IDisposable).Dispose();
            this.DataContext = null;
        }
    }
}
